/*
auto-generated by: https://github.com/pmndrs/gltfjsx
*/
import React, { useRef } from 'react'
import { useGLTF } from '@react-three/drei/useGLTF'

import { GLTF } from 'three/examples/jsm/loaders/GLTFLoader'

type GLTFResult = GLTF & {
  nodes: {
    Plane001_0: THREE.Mesh
    ['Plane.001_1_1']: THREE.Mesh
    Circle001_0: THREE.Mesh
    ['Circle.001_1_1']: THREE.Mesh
    staris: THREE.Mesh
    hamacas: THREE.Mesh
    tobogan: THREE.Mesh
    Cube001_0: THREE.Mesh
    ['Cube.001_1_1']: THREE.Mesh
    Cube002_0: THREE.Mesh
    ['Cube.002_1_1']: THREE.Mesh
    Plane004_0: THREE.Mesh
    ['Plane.004_1_1']: THREE.Mesh
    ['Plane.004_2_2']: THREE.Mesh
  }
  materials: {
    grass: THREE.MeshStandardMaterial
    dirt: THREE.MeshStandardMaterial
    marble: THREE.MeshStandardMaterial
    water: THREE.MeshStandardMaterial
    metal: THREE.MeshStandardMaterial
    green_metal: THREE.MeshStandardMaterial
    sidewalk: THREE.MeshStandardMaterial
    asfalt: THREE.MeshStandardMaterial
    cordon: THREE.MeshStandardMaterial
  }
}

export default function Model(props: JSX.IntrinsicElements['group']) {
  const group = useRef<THREE.Group>()
  const { nodes, materials } = useGLTF('/model/plaza.glb') as GLTFResult
  return (
    <group ref={group} {...props}>
      <group position={[-2.5, 0, -35.03]} scale={[4.85, 4.85, 4.85]}>
        <mesh material={materials.grass} geometry={nodes.Plane001_0.geometry} />
        <mesh material={materials.dirt} geometry={nodes['Plane.001_1_1'].geometry} />
      </group>
      <group position={[3.08, 1.63, 20.73]} scale={[7.68, 7.68, 7.68]}>
        <mesh material={materials.marble} geometry={nodes.Circle001_0.geometry} />
        <mesh material={materials.water} geometry={nodes['Circle.001_1_1'].geometry} />
      </group>
      <mesh
        material={materials.marble}
        geometry={nodes.staris.geometry}
        position={[36.56, 0.12, 66.47]}
        rotation={[0, 0.7, 0]}
      />
      <mesh
        material={materials.metal}
        geometry={nodes.hamacas.geometry}
        position={[-29.43, -0.24, 50.05]}
        rotation={[0, 0.44, 0]}
        scale={[0.15, 0.15, 0.15]}
      />
      <mesh
        material={materials.metal}
        geometry={nodes.tobogan.geometry}
        position={[-14.31, 0.83, 57.21]}
        rotation={[0, 1.23, 0]}
        scale={[1.11, 1.11, 1.11]}
      />
      <group position={[-2.47, 0, -40.7]} scale={[1.71, 1.71, 1.71]}>
        <mesh material={materials.marble} geometry={nodes.Cube001_0.geometry} />
        <mesh
          material={materials.green_metal}
          geometry={nodes['Cube.001_1_1'].geometry}
        />
      </group>
      <group position={[-2.47, 0, -40.7]}>
        <mesh material={materials.marble} geometry={nodes.Cube002_0.geometry} />
        <mesh
          material={materials.green_metal}
          geometry={nodes['Cube.002_1_1'].geometry}
        />
      </group>
      <group position={[-2.57, -0.8, -74.66]} scale={[66.57, 8.47, 8.47]}>
        <mesh material={materials.sidewalk} geometry={nodes.Plane004_0.geometry} />
        <mesh material={materials.asfalt} geometry={nodes['Plane.004_1_1'].geometry} />
        <mesh material={materials.cordon} geometry={nodes['Plane.004_2_2'].geometry} />
      </group>
    </group>
  )
}

useGLTF.preload('/plaza.glb')
